/* wagon-ESP-OSC
 *  un wagon radio-guidÃ©
 *  plateforme ESP8266 ESP-12
 *  commande moteur Olimex BB-L298
 *  protocole rÃ©seau OSC
 *  SNHack gepeto@du-libre.org
 *  Codes sous licences GPLV3
 */

/* projet LOCO-DOM
 *  Arduino 1.6.5-rc5 , esp 2.0.0 en json
 *  lib esp8266-OSC, EspSoftSerial
 *
 *  IP du rÃ©seau 192.168.0.x/24
 *  les loco sont de x= 81 a 91
 *  ports 9081
 * Connexions ESP-12 BBL-298
 * |-                |   ESP-12   |          |        -|
   |-                |      RST   |       TXD|        -|
   |LDR              | ADC        |       RXD|       - |
   |-                |CH_P        |    GPIO4 |  1 RFID |
   |4 BBL            |   GPIO16   |    GPIO5 |        -|
   |3 BBL            |   GPIO14   |    GPIO0 |        -|
   |led bleu2 BBL-298|   GPIO12   |    GPIO2 |        -|
   |led verte        |   GPIO13   |   GPIO15 |led rouge|
   |-                |   VCC 3V   |       GND|        -|
 * Avec NodeCu
 *  2   D4  GPIO 02
 *  3   D5  GPIO 14
 *  4   D6  GPIO 12
 * RFID TX
 *   D7  GPIO 13
 */
// WIFI
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <Ticker.h> // gestion des timer
//MDNSResponder mdns;
// OSC
//#include <OSCBundle.h>
#include <OSCMessage.h>
#include <OSCBoards.h>
//port numbers for OSC
#define MONIT true
#define TAILLE_PUCE 12
#define TAILLE_TABLEAU_PUCES 273 // 21 x 13
const int NBR_TABLOTPS = 6;
const int nbr_max_de_puce = 21;
const unsigned int inPort = 9081;
//destination IP pour la trace OSC
IPAddress MonitIP(192, 168, 0, 99); // IP et port du moniteur
const unsigned int MonitPort = 9998; // suivi normal
IPAddress DebugIP(192, 168, 0, 123); // IP et port de debug
const unsigned int DebugPort = 9999;
WiFiUDP udpin;
WiFiUDP udpout;
//Ticker zou; // OSC envoi position
//Ticker init_rfid; // init port rfid
Ticker ticker_batterie; // verif tension
#include <ArduinoJson.h>
#include "FS.h"
// serial
#include <EspSoftSerialRx.h>
EspSoftSerialRx rfid;
const char* ssid     = "LOCOMO";
const char* password = "0123456789";
char* nomhost  = "LOCO-2"; // le nom iendra de l'ip
char* nomloco = "LOCO-"; // debut du nom de la loco
int noloco = 2; // no de la loco
char* OSCVar = "/LOCO-2";

// DHCP donc pas besoin
//IP
//IPAddress (192,168,IPC,IPD);
int IPC = 0;
int IPD = 81;

//Brochage
// Driver moteur - NodeCU
const int enA = 2;  //nodeCU D4
const int in1 = 12; //nodeCU D6
const int in2 = 14; //nodeCU D5
const int ENTREERFID = 13 ; //NodeCU D7

// Olimex ESP8266-DEV
// lecteur RFID
//const int ENTREERFID = 2 ;
//const int enA = 14;
//const int in1 = 13;
//const int in2 = 12;

// ESP8266 platine ESP-12
// lecteur RFID
//const int ENTREERFID = 2 ; //ESP12
//const int enA = 12;
//const int in1 = 14;
//const int in2 = 16;


int vitesse_mini = 199; // vaincre les frotements
int vitesse_actuelle = 0 ; // vitesse actuelle
int vitesse_temp = 0;
int sens = 1;
uint32_t temps_boucle_total = 14000 ; // en milli seconde
uint32_t temps_a_faire = 0;
uint32_t temps_depart = 0;
uint32_t temps_inter = 0;
uint32_t temps_inter_init = 0;
uint32_t temps_tot_puce = 0;
int tablo_vitesse = 0;
int rampe_mini = 20; // >0 AV <0 ARR
int rampe = 0;
char buf0[] = "00000000000000000000";
char tag[TAILLE_PUCE + 1];
char tag2[TAILLE_PUCE + 1];
unsigned char val = 0x00;
int nbr_de_puce = 10;
int no_puce_actuelle = 0;
int puce_a_trouver = 0;
int puce_derniere_lue = 0;
int puce_dinit = 0 ;
int tour = 0;
// tableau des puces rfid 20x12
//char TableauPuces[nbr_max_de_puce][TAILLE_PUCE] = {
char TableauPuces[nbr_max_de_puce][TAILLE_PUCE + 1] = {
  "999999999999", // puce 0 inexistante on commence a 1 pour json
  "0103FA187292", // 1
  "0103FA19E908", // 2
  "0103FA19fA1B", // 3
  "0103FA199475", // 4
  "0103FA1A6f8D", // 5
  "0103FA199475", // 6
  "0103FA1AE604", // 7
  "0103FA197A98", // 8
  "0103FA188262", // 9
  "0103FA186989", // 10
  "0103FA186999", // 11
  "0103FA186990", // 12
  "0103FA186991", // 13
  "0103FA186992", // 14
  "0103FA186993", // 15
  "0103FA186994", // 16
  "0103FA186995", // 17
  "999999999996", // 18
  "999999999997"  // 19
};

uint32_t TableauTemps[nbr_max_de_puce + 1][NBR_TABLOTPS]; // temps entre 2 puce, 3 vitesses
// 0 = temps total de la boucle a differente vitesse
// 1 = temps entre puce max et la 1
// 2 = tps entre 1 et 2
// 3 = tps entre 2 et 3
// etc
// [][n] n= vitesse moteur pour ce tableau

int commande = 0; // no de la commande en cours


void rfid_port_init() { // re initialisation du port rfid les 10s
  Serial.println("init rfid");
  rfid.service();
}
void jesuisla() { // envoie OSC /msg if position vitesse
  OSCMessage zouzou(OSCVar);
  zouzou.add("cmd puce vits tps ");
  zouzou.add((int32_t)commande); // commande en cours
  zouzou.add((int32_t)no_puce_actuelle);
  zouzou.add((int32_t)vitesse_actuelle);
  zouzou.add((int32_t)(millis() / 1000));
  udpout.beginPacket(MonitIP, MonitPort);
  zouzou.send(udpout);
  udpout.endPacket();
  udpout.beginPacket(DebugIP, DebugPort);
  zouzou.send(udpout);
  udpout.endPacket();
  zouzou.empty(); // free space occupied by
}
int Verif_stop() { // stop hors de la boucle
  OSCMessage msgstop;
  int size;
  char puce_char[] = "  ";
  if ( (size = udpin.parsePacket()) > 0)
  {
    while (size--)
      msgstop.fill(udpin.read());

    if (!msgstop.hasError()) {
      // /stop immediat moteur et commande
      msgstop.dispatch("/stop", ArretMoteur);  // commande=0
      return (0);
    }
    udpin.flush();
  }
  return (1);
}

bool MonitMsg(char debugbla[], int debugint) {
  sprintf(OSCVar, "/LOCO-%d/%s", noloco, debugbla);
  if (MONIT) Serial.println(OSCVar);
  OSCMessage envoi(OSCVar);
  //envoi.add(debugbla);
  envoi.add(debugint);

  udpout.beginPacket(MonitIP, MonitPort);
  envoi.send(udpout);
  udpout.endPacket();

  udpout.beginPacket(DebugIP, DebugPort);
  envoi.send(udpout);
  udpout.endPacket();
  envoi.empty();
}

void Verif_Tension() { // lit ADC pour voir si tension entre 9 et 12.5
  int Vbatterie = 0;
  Vbatterie = analogRead(A0);
  MonitMsg("VBATTERIE", Vbatterie);
  if (Vbatterie < 300) { // a voir ..
    //Vitesse_moteur(0, 0);
    MonitMsg("ERR/VBATTERIE", Vbatterie);
  }
}
int Lit_Serie() { //retourne rien sauf si puce lu
  strncpy(tag, buf0,  TAILLE_PUCE + 1);
  val = 0x00;
  int i = 0;
  if (rfid.read(val)) {
    //Serial.println(val, HEX );
    // on saute avec le start 0x02 et stop bit 0x03
    if (val == 0x02) { // debut de puce
      strncpy(tag, buf0,  TAILLE_PUCE + 1);
      for (i = 0; i <= (TAILLE_PUCE + 1 ); i++) {
        rfid.read(val);
        if (MONIT) Serial.print(i);
        if (MONIT) Serial.println(val, HEX );        //
        tag[i] = (char)val;
      }
      tag[TAILLE_PUCE] = '\0'; // on ferme ici
      MonitMsg(tag, 101);
      if (MONIT) Serial.print("tag= ");
      if (MONIT) Serial.println(tag);
      rfid.read(val) ; //flush
      rfid.read(val) ; //flush
      return (0);
    }
  }
  return (1);
}
int Lit_Serie_Attente() { // en attente du puce
  strncpy(tag2, buf0,  TAILLE_PUCE + 1);
  int j = 0;
  int k = 0;
  while ( true ) { // tant que pas de demande de stop??
    val = 0x00;
    if (rfid.read(val)) {
      //Serial.print(j);
      //Serial.println(val, HEX );
      if ( val != 0x02 && val != 0x03 ) {
        ; // on saute le start 0x02
        tag2[j] = (char)val;
        if (j == TAILLE_PUCE - 1 ) { // si complet ou stop bit 0x03
          tag2[TAILLE_PUCE ] = '\0'; // on ferme ici
          MonitMsg(tag2, 100);
          if (MONIT) Serial.print("tag ");
          if (MONIT) Serial.println(tag2);
          rfid.read(val) ; //flush
          rfid.read(val) ; //flush
          return (0);
        }
        j++;
      }
    }
    delay(20);
  }
}

int Lit_rfid() {
  // mise en forme de la lecture rfid
  //retourne le no_puce
  //Serial.println("attente rfid");
  int i = 0;
  strncpy( tag, buf0, TAILLE_PUCE + 1);
  for (i = 0; i <= (TAILLE_PUCE - 1); i++) {
    val = 0x00;
    if (rfid.read(val)) {
      tag[i] = '\0'; // Null
      // on saute avec le start 0x02 et stop bit 0x03
      if ( (val == 0x03) || (val == 0x02)) {
        break;
      }
      //      Serial.print(i);
      //      Serial.print(" ");
      //      Serial.print((char)val);
      //      Serial.print(" ");
      //    Serial.println(val, HEX );
      tag[i] = (char)val;

      if (i == (TAILLE_PUCE - 1) ) { // 11 digit read is complete
        tag[TAILLE_PUCE] = '\0'; // Null on ferme la chaine
        if (MONIT) Serial.print(tag);
        for (i = 1; i <= nbr_de_puce; i++) {
          if (strcmp(tag, TableauPuces[i]) == 0) {
            puce_derniere_lue =  i;
            if (MONIT) Serial.print(" lit rfid ");
            if (MONIT) Serial.println(i);
            MonitMsg("LITPUCE", puce_derniere_lue);
            //MonitMsg(tag,puce_derniere_lue);
            rfid.read(val) ; //flush
            rfid.read(val) ; //flush
            return (0);
          }
        }
        MonitMsg("PUCE INCONNUE", 999);
        MonitMsg(tag, 999);
        return (99);
      }
    }
  }
  return (1);
}
/*
int Lit_rfid() {
  //retourne le no_puce venant du tableau si lecture
  if (Lit_Serie() == 0 ) {
    for (int i = 1; i <= nbr_de_puce; i++) {
      if (strcmp(tag, TableauPuces[i]) == 0) {
        puce_derniere_lue =  i;
        if (MONIT) Serial.print(" lit_rfid ");
        if (MONIT) Serial.println(i);
        MonitMsg("PUCE", puce_derniere_lue);
        return (0);
      }
    }
    MonitMsg("ERR/PUCEINCONNUE", 999);
    MonitMsg(tag, 999);
    return (999);
  }
  return (100);
}
*/
bool MonitOSC(char debugbla[], int debugint) {
  OSCMessage envoi(debugbla);
  envoi.add(debugint);

  udpout.beginPacket(MonitIP, MonitPort);
  envoi.send(udpout);
  udpout.endPacket();

  udpout.beginPacket(DebugIP, DebugPort);
  envoi.send(udpout);
  udpout.endPacket();
  envoi.empty();
}
int Vitesse_moteur(int moteur, int accel) {
  int i = 0;
  if (moteur == 0 && accel == 0) { //arret brutale
    analogWrite(enA, 0);
    vitesse_actuelle = 0;
    tour = 0;
    sens = 1;
    return (0);
  }
  moteur = abs(moteur);
  if (moteur > 1024) // filtre le max
    moteur = 1024;
  if (moteur < vitesse_mini && moteur > 0) {
    moteur = vitesse_mini;
    MonitMsg("MOTEUR/VITESSE_MINI", vitesse_mini);
  }
  MonitMsg("MOTEUR/VITESSE", moteur);
  if (MONIT) Serial.print("vitesse ");
  if (MONIT) Serial.print(moteur);
  if (MONIT) Serial.print(" acel ");
  if (MONIT) Serial.println(accel);
  if ( accel < 0 ) {
    sens = -1;
    moteur = -moteur; // ARRIERE
  } else {
    sens = 1;
  }
  accel = abs(accel);
  if ( accel > 500 || accel < rampe_mini ) accel = rampe_mini;
  // en dessous de 20 ca plante !!
  // sinon on garde accel donne
  if (vitesse_actuelle > moteur) {
    for (i = vitesse_actuelle; i >= moteur; i = i - 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      } else {
        //Arriere;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
      //if (MONIT) Serial.println(i);
    }
  } else {
    for ( i = vitesse_actuelle; i <= moteur; i = i + 20) {
      if ( i >= 0 ) {
        //Avant;
        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      } else {
        //Arriere;
        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      }
      analogWrite(enA, abs(i));
      delay(accel); // rampe
      //if (MONIT) Serial.println(i);
    }
  }
  vitesse_actuelle = moteur;
  //analogWrite(enA, moteur);
  return (0);
}
// COMMANDES
void ArretMoteur(OSCMessage &msg) {
  commande = 0;
  Serial.println("ArretMoteur /stop");
  MonitMsg("STOP", 0);
  analogWrite(enA, 0);
  vitesse_actuelle = 0;
}
void MoteurControl(OSCMessage &msg) {
  // met le moteur Ã  la vitesse reÃ§ue, accel
  //commande = 1; ne change pas l'ordre en cours
  Serial.println("/moteur");
  Vitesse_moteur(msg.getInt(0), msg.getInt(1));
}

// remplir tableau avec les puces présentées au lecteur
// /inittableaupuce i nbr_de_puce
//
void InitTableauPuces1par1(OSCMessage &msg) {
  int i = 0;
  int puce = 0;
  char *buf[TAILLE_PUCE];
  Serial.println("/inittableaupuce");
  commande = 7;
  if (msg.getInt(0) > 0) {
    nbr_de_puce = abs((int) msg.getInt(0));
  } else {
    nbr_de_puce = nbr_max_de_puce;
  }
  Serial.println(nbr_de_puce);
  MonitMsg("INIT/TABLEAU/Tableau", nbr_de_puce);
  // tour pour nbr de puce total
  MonitMsg("INIT/TABLEAU/ATTENTE/PUCE1", 0 );
  while (Lit_Serie() > 0) {
    Serial.println("puce ? 1 ");
    delay(2000);
  }
  Serial.println(tag);
  strncpy( TableauPuces[1], tag,   TAILLE_PUCE);
  MonitMsg(TableauPuces[1], 1);
  MonitMsg("INIT/TABLEAU/ATTENTE/PUCES", nbr_de_puce );
  for (puce = 2; puce <= nbr_de_puce; puce++) { // On doit dÃ©jÃ  connaitre la puce 1
    while (Lit_Serie() > 0) {
      Serial.print("puce? ");
      Serial.print(puce);
      delay(2000);
      Serial.println(" :");
    }
    if (strcmp(tag, TableauPuces[1]) == 0 ) {
      nbr_de_puce = puce;
      break;
    }
    strncpy( TableauPuces[puce], tag,  TAILLE_PUCE) ;
    Serial.print(tag);
    Serial.print(" ");
    Serial.println(puce);
    MonitMsg(tag, puce );
  }
  Serial.print  ("nbr de puce ok ");
  Serial.println(puce);
  MonitMsg("INIT/TABLEAU/OK", puce);
  Vitesse_moteur(0, 0);
}
//
// Récupere la config de la flash
// des fichiers config.json et temps.json
//
int Reprendre_config() {
  if (!SPIFFS.begin()) {
    if (MONIT) Serial.println("Failed to mount file system");
  }
  File configFile = SPIFFS.open("/config.json", "r");
  if (!configFile) {
    if (MONIT) Serial.println("pb de lecture de /config.json");
    nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
  } else {
    size_t size = configFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("Config file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);

    // We don't use String here because ArduinoJson library requires the input
    // buffer to be mutable. If you don't use ArduinoJson, you may as well
    // use configFile.readString instead.
    configFile.readBytes(buf.get(), size);

    StaticJsonBuffer<400> jsonBuffer;
    JsonObject& circuit = jsonBuffer.parseObject(buf.get());
    //circuit.printTo(Serial);
    if (!circuit.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /config.json");
      MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
      return (1);
    }
    if ( circuit["IPD"] < 81 || circuit["IPD"] > 90 ) IPD = 81 ; // ne devrait pas arriver
    if ( circuit["nbr_de_puce"] > 3)          nbr_de_puce = circuit["nbr_de_puce"];
    else nbr_de_puce = nbr_max_de_puce;
    if (circuit["vitesse_mini"]        > 100)  vitesse_mini        = circuit["vitesse_mini"];
    if (MONIT) Serial.println(IPD); // vient du setup ip[3]
    if (MONIT) Serial.println(nomloco); // vient du setup ip[3] donne nom LOCO-..
    if (MONIT) Serial.println(nbr_de_puce);
    if (MONIT) Serial.println(vitesse_mini);
    MonitMsg(nomloco, 0);
    delay(20);
    MonitMsg("FLASH/CONF/NBR_PUCE", nbr_de_puce);
    delay(20);
    MonitMsg("FLASH/CONF/vitesse_mini", vitesse_mini);
    if (nbr_de_puce > 0) {
      for ( int i = 0; i < nbr_de_puce; i++) {
        if (circuit["tablepuces"][i]) {
          strncpy(TableauPuces[i + 1], circuit["tablepuces"][i], TAILLE_PUCE);
          if (MONIT) Serial.print(TableauPuces[i + 1]);
          if (MONIT) Serial.print(" puce:");
          if (MONIT) Serial.println(i + 1);
          MonitMsg(TableauPuces[i + 1] , i + 1);
          delay(20);
        }
        else {
          if (MONIT) Serial.println("reinit ");
          MonitMsg("FLASH/CONF/ERR/RESETCONF", nbr_de_puce);
          FlashTableauPuces();
          break;
        }
      }
    }
  }
  if (MONIT) Serial.println(" ");
  configFile.close();

  File tempsFile = SPIFFS.open("/temps.json", "r");
  if (!tempsFile) {
    if (MONIT) Serial.println("pb de lecture de /temps.json");
    nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
  } else {
    size_t size = tempsFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps file size is too large");
      return 3;
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);

    // We don't use String here because ArduinoJson library requires the input
    // buffer to be mutable. If you don't use ArduinoJson, you may as well
    // use configFile.readString instead.
    tempsFile.readBytes(buf.get(), size);

    StaticJsonBuffer<1000> json2Buffer;
    JsonObject& jsontablotps = json2Buffer.parseObject(buf.get());
    if (MONIT) jsontablotps.printTo(Serial);
    if (!jsontablotps.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps.json");
      MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
      return (1);
    }
    if (nbr_de_puce > 0) {
      char tablo[6];
      for (int j = 0; j <= NBR_TABLOTPS; j++) {
        sprintf(tablo, "tablo%1d", j);
        for ( int i = 0; i <= nbr_de_puce; i++) {
          if (jsontablotps[tablo][i]) {
            TableauTemps[i][j] = (uint32_t)jsontablotps[tablo][i];
            MonitMsg(tablo, (int) jsontablotps[tablo][i]);
            delay(20);
          } else {
            TableauTemps[i][j] = 0;
          }
        }
      }
    }

    tempsFile.close();
  }
  if (MONIT) Serial.println("");
  return (0);
}

void DonneFlash(OSCMessage & msg) {
  // commande = 13; transparente
  File configFile = SPIFFS.open("/config.json", "r");
  if (!configFile) {
    if (MONIT) Serial.println("pb de lecture de /config.json");
  } else {
    size_t size = configFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("Config file size is too large");
    }
    std::unique_ptr<char[]> buf2(new char[size]);
    configFile.readBytes(buf2.get(), size);
    StaticJsonBuffer<400> jsonBuffer;
    JsonObject& circuit = jsonBuffer.parseObject(buf2.get());
    if (!circuit.success()) {
      if (MONIT) Serial.println("donneflash parse pb de lecture de /config.json");
    }
    else {
      MonitMsg(nomloco, 0);
      //MonitMsg("IPD", circuit["IPD"]);
      delay(20);
      MonitMsg("FLASH/DONNE/nbr_de_puce", circuit["nbr_de_puce"]);
      delay(20);
      MonitMsg("FLASH/DONNE/vitesse_mini", circuit["vitesse_mini"]);
      if (MONIT) circuit.printTo(Serial);
      if (MONIT) Serial.println("");
      for (int i = 0; i < nbr_de_puce; i++) {
        strncpy(tag, circuit["tablepuces"][i], TAILLE_PUCE);
        MonitMsg(tag, i + 1);
        delay(20);
      }
      configFile.close();
    }
  }
  File tempsFile = SPIFFS.open("/temps.json", "r");
  if (!tempsFile) {
    if (MONIT) Serial.println("pb de lecture de /temps.json");
    nbr_de_puce = nbr_max_de_puce;
    MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
  } else {
    size_t size = tempsFile.size();
    if (size > 1024) {
      if (MONIT) Serial.println("temps file size is too large");
    }
    // Allocate a buffer to store contents of the file.
    std::unique_ptr<char[]> buf(new char[size]);

    // We don't use String here because ArduinoJson library requires the input
    // buffer to be mutable. If you don't use ArduinoJson, you may as well
    // use configFile.readString instead.
    tempsFile.readBytes(buf.get(), size);

    StaticJsonBuffer<1000> json2Buffer;
    JsonObject& jsontablotps = json2Buffer.parseObject(buf.get());

    if (!jsontablotps.success()) {
      if (MONIT) Serial.println("parse pb de lecture de /temps.json");
      MonitMsg("FLASH/ERR/LECTURE", nbr_de_puce);
    } else {
      if (MONIT) Serial.println("tabltop: ");
      if (MONIT) jsontablotps.printTo(Serial);
      if (MONIT) Serial.println("");
      //for (int j = 0; j <= NBR_TABLOTPS; j++) {
      //  for (int i = 0; i <= nbr_de_puce; i++) {
      //    if (MONIT) Serial.print(TableauTemps[i][j]);
      //    if (MONIT) Serial.print(" ");
      //  }
      //  if (MONIT) Serial.println("");
      //}
    }
  }
}
//
// Sauvegarde des parametres dans la flash
//

/*
 * void EnvoiFlash(OSCMessage & msg) {
  //commande = 8; transparente
  StaticJsonBuffer<400> jsonBuffer;
  //JsonObject& circuit = jsonBuffer.createObject();
  msg.getString(0,jsonBuffer,msg.size);
  if (MONIT) Serial.println("sauvegarde config.json ");
  if (FlashTableauPuces() == 0) {
    if (MONIT) Serial.println("config.json sauvé");
    MonitMsg("sauveflash config.json ok", nbr_de_puce);
  }
}
*/
int FlashTableauPuces() {
  if (MONIT) Serial.println("go config.json ");
  StaticJsonBuffer<400> jsonBuffer;
  JsonObject& circuit = jsonBuffer.createObject();
  circuit["nom"] = WiFi.hostname();
  circuit["IPD"] = IPD;
  circuit["nbr_de_puce"]         = nbr_de_puce;
  circuit["vitesse_mini"]        =  vitesse_mini ;
  JsonArray& puces = circuit.createNestedArray("tablepuces");
  for (int i = 0; i < nbr_de_puce; i++) {
    puces.add( TableauPuces[i + 1]);
  }
  File configFile = SPIFFS.open("/config.json", "w");
  if (!configFile) {
    if (MONIT) Serial.println("Failed to open config file for writing");
    MonitMsg("FLASH/ERR/ECRITURE", nbr_de_puce);
    return (2);
  }
  circuit.printTo(configFile);
  MonitMsg("FLASH/OK", nbr_de_puce);
  circuit.printTo(Serial);
  configFile.close();


  StaticJsonBuffer<1000> json2Buffer;
  JsonObject& jsontablotps = json2Buffer.createObject();
  bool flashtab = false;
  if (commande == 49) flashtab = true ;
  char tablo[6];
  JsonArray& tablo0 = jsontablotps.createNestedArray("tablo0");
  for (int i = 0; i <= nbr_de_puce; i++) {
    if (flashtab) {
      TableauTemps[i][0] = 0;
      TableauTemps[0][0] = 1000;
    }
    tablo0.add( TableauTemps[i][0]);
  }
  JsonArray& tablo1 = jsontablotps.createNestedArray("tablo1");
  for (int i = 0; i <= nbr_de_puce; i++) {
    if (flashtab) {
      TableauTemps[i][1] = 0;
      TableauTemps[0][1] = 1000;
    }
    tablo1.add( TableauTemps[i][1]);
  }
  JsonArray& tablo2 = jsontablotps.createNestedArray("tablo2");
  for (int i = 0; i <= nbr_de_puce; i++) {
    if (flashtab) {
      TableauTemps[i][2] = 0;
      TableauTemps[0][2] = 800;
    }
    tablo2.add( TableauTemps[i][2]);
  }
  JsonArray& tablo3 = jsontablotps.createNestedArray("tablo3");
  for (int i = 0; i <= nbr_de_puce; i++) {
    if (flashtab) {
      TableauTemps[i][3] = 0;
      TableauTemps[0][3] = 500;
    }
    tablo3.add( TableauTemps[i][3]);
  }
  JsonArray& tablo4 = jsontablotps.createNestedArray("tablo4");
  for (int i = 0; i <= nbr_de_puce; i++) {
    if (flashtab) {
      TableauTemps[i][4] = 0;
      TableauTemps[0][4] = -1000;
    }
    tablo4.add( TableauTemps[i][4]);
  }
  JsonArray& tablo5 = jsontablotps.createNestedArray("tablo5");
  for (int i = 0; i <= nbr_de_puce; i++) {
    if (flashtab) {
      TableauTemps[i][5] = 0;
      TableauTemps[0][5] = -800;
    }
    tablo5.add( TableauTemps[i][5]);
  }
  JsonArray& tablo6 = jsontablotps.createNestedArray("tablo6");
  for (int i = 0; i <= nbr_de_puce; i++) {
    if (flashtab) {
      TableauTemps[i][6] = 0;
      TableauTemps[0][6] = -500;
    }
    tablo6.add( TableauTemps[i][6]);
  }
  if (MONIT) {
    Serial.println("tablo tps: ");
    jsontablotps.printTo(Serial);
    Serial.println(" ");
  }
  File tempsFile = SPIFFS.open("/temps.json", "w");
  if (!tempsFile) {
    if (MONIT) Serial.println("Failed to open tempsFile file for writing");
    MonitMsg("FLASH/ERR/ECRITURE", nbr_de_puce);
    return (3);
  }
  jsontablotps.printTo(tempsFile);
  MonitMsg("FLASH/OK", nbr_de_puce);

  tempsFile.flush();
  delay(1000);
  tempsFile.close();


  return (0);
}
void SauveFlash(OSCMessage & msg) {
  //commande = 8; transparente
  if (nbr_de_puce == 0) nbr_de_puce = msg.getInt(0);
  if (MONIT) Serial.println("sauvegarde config.json ");
  if (FlashTableauPuces() == 0) {
    if (MONIT) Serial.println("config.json sauvé");
    MonitMsg("FLASH/SAUVEGARDE/OK", nbr_de_puce);
  }
}
void SauveNbrPuce(OSCMessage & msg) {
  if (msg.getInt(0) > 5) {
    nbr_de_puce = msg.getInt(0);
    FlashTableauPuces();
  }
}

void SauveIPD(OSCMessage & msg) { // IP entre 80 et 90
  if (msg.getInt(0) > 0) {
    IPD = msg.getInt(0);
    if (IPD > 80 && IPD < 91) {
      Serial.println(IPD);
      Serial.println("flash et reboot");
      MonitMsg("FLASH/OK/REBOOT", IPD);
      FlashTableauPuces();
      delay(2000);
      ESP.restart();
    }
  }
}
void SauveVitessemini(OSCMessage & msg) {
  if (msg.getInt(0) > 0) {
    vitesse_mini = msg.getInt(0);
    FlashTableauPuces();
  }
}
//
// Initialisation totale
//
void Initialisation_Tableau(OSCMessage & msg) {
  // Placer la loco juste avant la puce qui sera la 1
  // la loco fait un tour complet doucement pour connaitre les puces
  int i = 0;
  int puce = 0;
  commande = 2;
  val = 0x00;
  char tagavant[TAILLE_PUCE + 1] = "";
  //zou.detach();
  if (msg.getInt(0) > 0) {
    nbr_de_puce = abs((int) msg.getInt(0));
    if (MONIT) Serial.print("/init");
    if (MONIT) Serial.println(nbr_de_puce);
    MonitMsg("INIT", nbr_de_puce);
    Vitesse_moteur(800, 0);
    uint32_t temps = (uint32_t)millis();
    strncpy( TableauPuces[1], buf0,  TAILLE_PUCE) ;
    strncpy(tagavant, buf0,  TAILLE_PUCE) ;
    for (puce = 1; puce <= nbr_de_puce; puce++) {
      temps = (uint32_t)millis();
      while (Lit_Serie() > 0) delay(30);
      /*
      MonitMsg("INIT/PUCE", puce);

       * if (strncmp(TableauPuces[1], tag, TAILLE_PUCE) == 0  && puce >= 3) { // puce 1 avant fin presumee
        nbr_de_puce = puce - 1;
        if (MONIT) Serial.println("puce 1 donc fin avant ");
        break;
      }
      */
      if ( strncmp(tagavant, tag, TAILLE_PUCE) == 0 ) { // si pas meme puce lue 2 fois
        MonitMsg("INIT/PUCELUEIDEM", puce);
        puce--; // une boucle pour rien
      } else {
        strncpy( TableauPuces[puce], tag,  TAILLE_PUCE) ;
        strncpy( tagavant, tag,  TAILLE_PUCE) ;
        MonitMsg("INIT/PUCELUEOK", puce);
        //TableauTemps800[puce][0] =  (uint32_t)millis() - temps;
        if (MONIT) Serial.print("puce ");
        if (MONIT) Serial.print(TableauPuces[puce]);
        if (MONIT) Serial.print(" no ");
        if (MONIT) Serial.println(puce);
        //MonitMsg(TableauPuces[puce], 0);
        strncpy(tag, buf0,  TAILLE_PUCE) ;
        delay(500); // pour ne pas lire la meme puce
      }
    }
    MonitMsg("INIT/NBRPUCEOK", nbr_de_puce);
    Vitesse_moteur(0, 0);
    FlashTableauPuces();
  }
}

void Initialisation_Vitesse(OSCMessage & msg) {
  // msg 0 = no du tableau 0=1000, 1 = 800, 2 = 500; sens +/-
  // on demare sur la 1 on a deja le tableau de puce
  // on remplie les tableaux Avant et Arr pour 3 vitesses (vitesse_actuelle)
  // TableauTemps[nbr_max_de_puce][3] la vitesses est dans puce 0
  commande = 50;
  tablo_vitesse =  abs(msg.getInt(0));
  if (tablo_vitesse == 99) { //init des tableau
    TableauTemps[0][0] = 0;
    commande = 49;
    FlashTableauPuces(); // init les tableau temps a 0
    TableauTemps[0][0] = 1000;
    MonitMsg("INIT/TABLEAUTEMPS/INITA0", 0);
    commande = 0;
  } else {
    if (tablo_vitesse >= 1 && tablo_vitesse <= NBR_TABLOTPS) {
      sens = 0;
      puce_dinit = 2 ;
      if (TableauTemps[0][tablo_vitesse] <= 0) {
        sens = -10;
        puce_dinit = nbr_de_puce ;
      }
      Vitesse_moteur(abs(TableauTemps[0][tablo_vitesse]), sens); // vitesse vien de l'init des variables
      commande = tablo_vitesse + 50;
      temps_boucle_total = (uint32_t)millis();
      temps_inter_init = (uint32_t)millis();
      MonitMsg("INIT/TABLEAUTEMPS", TableauTemps[0][tablo_vitesse] );
      delay(20);
      MonitMsg("INIT/TABLEAUTEMPS", TableauTemps[0][tablo_vitesse] );
      if (MONIT) Serial.print("/init_vitesse");
      if (MONIT) Serial.println(nbr_de_puce);
    }
  }
}
//
// GOTO iii puce temps acceleration
//
void Rendezvous(OSCMessage & msg) {
  // /goto iii puce temps rampe : se rendre a la puce xx en tant de temps
  commande = 3;
  int distance = 0;
  float vitesse = 0;
  int puce = 0;
  uint32_t temps_course = 0;
  puce_a_trouver = (int) msg.getInt(0);
  if (puce_a_trouver == 0 || puce_a_trouver > nbr_de_puce) {
    MonitMsg("GOTO/ERR/PASDEPUCE", puce_a_trouver);
  } else {
    temps_a_faire = (uint32_t)msg.getInt(1) ;
    temps_boucle_total = TableauTemps[0][0]; // meilleurs temps possible
    if (temps_a_faire > 5 * temps_boucle_total) {
      MonitMsg("GOTO/ERR/TEMPSTROPLONG", temps_a_faire);
    } else {
      rampe = (int) msg.getInt(2); // si <0 alors marche arriere
      if ( rampe < 0 ) {
        sens = -1;
      } else {
        sens = 1;
      }
      if (puce_derniere_lue == 0  ||  puce_derniere_lue > 90  ) { // on ne connait pas la puce depart
        if (MONIT) Serial.print("/rdv cherche premiere puce ");
        if (MONIT) Serial.println(puce_derniere_lue);
        MonitMsg("GOTO/ATTENTE_PUCE", 390);
        Vitesse_moteur(800, 0);
        while (Lit_rfid() >= 90 || puce_derniere_lue == 0  ) // on cherche la prochaine, renseigne puce_derniere_lue
          delay(200);
        no_puce_actuelle = puce_derniere_lue;
      }
      MonitMsg("GOTO/PUCE_DEPART", no_puce_actuelle );
      if (MONIT) Serial.print("/rdv de ");
      if (MONIT) Serial.print(puce_derniere_lue);
      if (MONIT) Serial.print(" a trouver ");
      if (MONIT) Serial.println(puce_a_trouver);
      temps_depart = (uint32_t)millis();
      temps_tot_puce = temps_depart;
      vitesse =  CalculVitesse(1000 ); // recalcule avec tableau 1000
      if (vitesse > 1010) {
        MonitMsg("GOTO/ERR/TEMPS_TROP_COURT", temps_boucle_total );
        vitesse = 1000;
      }
      if (vitesse < vitesse_mini) {
        MonitMsg("GOTO/ERR/TEMPS_TROP_LONG", 0 );
        vitesse = vitesse_mini;
      }
      if (MONIT) Serial.println(vitesse);
      MonitMsg("GOTO/VITESSE", (int) vitesse);
      temps_depart = (uint32_t)millis();
      Vitesse_moteur((int)vitesse, rampe); // on roule , pendant un certain temps
    }
  }
  // partie en corrigeant au fur et a mesure
}
//
int CalculVitesse( int tablo) {
  uint32_t temps_course = 0; //temps donne par le tableau
  uint32_t temps_restant = 0; //temps reel restant a faire
  float vitesse = 0;
  // tablo pour des vitesse 1000 ou 800 ou 500 ;
  if (tablo == 800 ) tablo = 1;
  else if (tablo = 500 ) tablo = 2;
  else tablo = 0;
  temps_restant = temps_a_faire - ( (uint32_t)millis() - temps_depart ) ;
  // puce devant plus grande
  if ((puce_a_trouver > puce_derniere_lue) && sens >= 0) {
    for (int p = puce_derniere_lue + 1; p == puce_a_trouver; p++) temps_course += TableauTemps[p][tablo];
  } else {
    if ((puce_a_trouver < puce_derniere_lue) && sens >= 0) {
      // puce devant plus petite et marche avant
      for (int p = puce_derniere_lue + 1; p == nbr_de_puce; p++) temps_course += TableauTemps[p][0];
      for (int p = nbr_de_puce; p == puce_a_trouver; p++) temps_course += TableauTemps[p][tablo];
    } else {
      if ((puce_a_trouver > puce_derniere_lue) && sens < 0) { //arriere
        for (int p = puce_derniere_lue; p == 1; p--) temps_course += TableauTemps[p][0];
        for (int p = nbr_de_puce; p == puce_a_trouver; p--) temps_course += TableauTemps[p][tablo];
      } else {
        if ((puce_a_trouver < puce_derniere_lue) && sens < 0) { //arriere
          for (int p = puce_derniere_lue; p == puce_a_trouver + 1; p--) temps_course += TableauTemps[p][tablo];
        } else {
          if ((puce_a_trouver == puce_derniere_lue)) { //si meme puce alors un tour complet
            for (int p = 1; p == nbr_de_puce; p++) temps_course += TableauTemps[p][0];
            tour += 2;
            if (MONIT) Serial.println("tour + 2");
            MonitMsg("GOTO/TOUR/1", tour);
          }
        }
      }
    }
  }
  MonitMsg("GOTO/TEMPSTABLEAURESTANT", temps_course);
  vitesse =  1000 * ((float)temps_restant / (float)temps_course);
  if (MONIT) Serial.println("recalculvitesse");
  if (MONIT) Serial.println(vitesse);
  return ((int)vitesse);
}

//
// / aller iii puce vitesse acceleration

bool Aller(int no_puce, int vitesse, int accel) {
  // aller jusqu'a la puce no_puce a vitesse
  if (MONIT) Serial.print("Aller ");
  if (MONIT) Serial.println(no_puce);
  MonitMsg("ALLER", no_puce);
  puce_a_trouver = no_puce;
  if (puce_a_trouver == 0 || puce_a_trouver > nbr_de_puce) {
    MonitMsg("ALLER/ERR/PASDEPUCE", puce_a_trouver);
  } else {
    temps_depart = (uint32_t)millis();
    temps_tot_puce = temps_depart;
    rampe = accel;
    Vitesse_moteur(vitesse, accel);
    if ((puce_a_trouver == puce_derniere_lue)) { //si meme puce alors un tour complet
      if (sens >= 0) tour  += 1;
      else tour  -= 1;
      if (MONIT) Serial.println("tour + 1");
      MonitMsg("ALLER/TOURPLUS1", tour);
    }
    return (true);
  }
  return (false);
}
//
void SeRendre(OSCMessage & msg) {
  // /aller ii puce vitesse : se rendre a la puce xx a n vitesse [acceleration]
  commande = 4;
  Aller((int)msg.getInt(0), (int)msg.getInt(1), (int)msg.getInt(2) );
}
void LitPuce(OSCMessage & msg) {
  commande = 6;
  Serial.println("lit");
  //zou.detach();
  while (Lit_Serie() > 0) delay(20);
}

void Ou(OSCMessage & msg) {
  // commande = 9; transparente
  //Serial.println("ou");
  //zou.attach(5, jesuisla);
  MonitMsg("PUCE/DERNIERELUE", puce_derniere_lue);
}
void Recup_Tension(OSCMessage & msg) {
  Verif_Tension();
}
//
//
void setup()
{
  TableauTemps[0][1] = 1000;
  TableauTemps[0][2] = 800;
  TableauTemps[0][3] = 500;
  TableauTemps[0][4] = -1000;
  TableauTemps[0][5] = -800;
  TableauTemps[0][6] = -500;
  TableauTemps[0][0] = 1000;
  Serial.begin(115200);
  // set all the motor control pins to outputs
  pinMode(enA, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  //digitalWrite(in1, LOW);
  //digitalWrite(in2, LOW);
  //digitalWrite(enA, LOW);
  // serial RFID
  rfid.begin(9600, ENTREERFID); //
  Serial.println(ESP.getChipId(), HEX);
  //setup ethernet part
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.mode(WIFI_STA);
  //WiFi.hostname(nomhost);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  //  DHCP donc pas fixÃ© ici
  //WiFi.config(IPAddress(192, 168, IPC, IPD), IPAddress(192, 168, IPC, IPD), IPAddress(255, 255, 255, 0));
  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println(ssid);
  Serial.println("IP address: ");
  IPAddress IPLOCAL = WiFi.localIP();
  IPD = (int)IPLOCAL[3];
  Serial.println(IPD);
  //Serial.println(WiFi.macAddress);
  noloco = abs(IPD - 80);
  sprintf(nomloco, "LOCO-%d", noloco);
  sprintf(OSCVar, "/LOCO-%d", noloco);
  Serial.println("hostname: ");
  Serial.println(nomloco);
  WiFi.hostname(nomloco);
  Serial.println(WiFi.hostname());
  Serial.println("Starting UDP");
  udpin.begin(inPort);
  Serial.print("Local port: ");
  Serial.println(udpin.localPort());

  delay(100);
  // envoi le bonjour
  MonitMsg("BONJOUR", (int32_t)ESP.getChipId());
  //recupere le s puce du fichier /puces.buf
  Reprendre_config();
  rfid.read(val) ; //flush
  rfid.read(val) ; //flush
  rfid.read(val) ; //flush
  //ArretMoteur();
  // verifier toutes les minute la batterie
  //ticker_batterie.attach(60, Verif_Tension);

  // placer jesuisla en boucle timer 1s
  //zou.attach(5, jesuisla);
  // init_rfid.attach(10, rfid_port_init); ?
  /*
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  analogWrite(enA, 500);
  delay(2000);
  analogWrite(enA, 700);
  delay(2000);
  analogWrite(enA, 900);
  */

}
//
void loop()
{
  // Lire la comande et executer le debut
  OSCMessage msgIN;
  int size;
  char puce_char[] = "  ";
  if ( (size = udpin.parsePacket()) > 0)
  {
    while (size--)
      msgIN.fill(udpin.read());

    if (!msgIN.hasError()) {
      // /stop immediat moteur et commande
      msgIN.dispatch("/stop", ArretMoteur);  // commande=0

      // /moteur ii vitesse +/- rampe (av/arr)
      //        rampe  <0 : marche arriere, 0 brutal
      msgIN.dispatch("/moteur", MoteurControl); //  commande=1 n cmd transparente

      // /init fait un tour pour decouvrir les puces, inittableau nbr_de_puce
      // /inittableau i nbr_de_puce
      msgIN.dispatch("/inittableau", Initialisation_Tableau);  // commande=2

      // /init fait un tour pour apprendre les temps de parcours
      msgIN.dispatch("/initvitesse", Initialisation_Vitesse);  // commande=19 /initvitesse i 0-5
      // 1 = vitesse 1000
      // 2 = 800
      // 3 = 500 4 = -1000 5 =-800 6 =-500
      // 99 = init des tableaux a 0

      // /goto iii puce temps(ms) +/-rampe (av/arr) va Ã  la puce dans le temps donnÃ©
      msgIN.dispatch("/goto", Rendezvous);      // commande=3

      // /aller iii puce vitesse rampe
      msgIN.dispatch("/aller", SeRendre);       // commande=4

      // /lit renvoi le code de la derniere puce lue
      msgIN.dispatch("/lit", LitPuce);          //   commande=6

      // /puces rempli le tableau avec les puce presentees devant la boucle a larret
      msgIN.dispatch("/puces", InitTableauPuces1par1);  // commande=7

      // /sauvepuces enregistre le tableau dans la flash
      msgIN.dispatch("/sauveflash", SauveFlash); // commande=8
      // /donnepuces renvoi les données de la flash
      msgIN.dispatch("/donneflash", DonneFlash); // commande=13

      // /ou renvoi la derniere puce lu
      msgIN.dispatch("/ou", Ou);                //  commande=9

      // /sauveip i IPD change IPD, enregistre la flash et reboot  commande= 14
      msgIN.dispatch("/sauveip", SauveIPD); // commande=14

      // /sauvevitessemini i vitesse_mini enregistre la vitesse_mini
      msgIN.dispatch("/sauvevitessemini", SauveVitessemini); // commande=15

      // /sauvenbrpuce i nbr_de_puce, enregistre
      msgIN.dispatch("/sauvenbrpuce", SauveNbrPuce); // commande=17

      // /vbatterie // renvoi le temoin batterie
      msgIN.dispatch("/batterie", Recup_Tension); // commande=18
    }
    udpin.flush();
  }
  // Lire une puce et continuer une commande en cours
  if (commande != 0) {
    if (commande != 2 && commande != 7) {
      if (commande == 6) {
        Lit_Serie();
      } else {
        //puce_derniere_lue revient de Lit_rfid
        if (Lit_rfid() == 0) {
          //sprintf(puce_char, "%d", puce_derniere_lue);
          //MonitOSC(puce_char, (uint32_t)millis());
          temps_inter = (uint32_t)millis() - temps_depart ;
          temps_tot_puce += temps_inter;
          //MonitMsg("temps ", temps_inter );
          //Serial.print("puce lue ");
          //Serial.print(puce_derniere_lue);
          //Serial.print(" a trouver ");
          //Serial.println(puce_a_trouver);
          if (commande == 3 && ( temps_a_faire + 3000 < ((uint32_t)millis() - temps_depart  ))) {// on laisse tomber a 3s rniere_lue);
            Vitesse_moteur(0, 0);
            MonitMsg("GOTO/ERR/TEMPSPASSE" , puce_derniere_lue);
            commande = 0;
          }
          /*
          if (commande == 3 && (abs(vitesse_actuelle) > 800) && (temps_a_faire - ((uint32_t)millis() - temps_depart) < 1000 )) { // ralentir 1s avant
            vitesse_actuelle = vitesse_actuelle - (sens * 100);
            if (abs(vitesse_actuelle) < 0) vitesse_actuelle = 0;
            analogWrite(enA, vitesse_actuelle);
            MonitMsg("goto rallenti" , puce_derniere_lue);
          }

          if ( commande == 4 && abs(vitesse_actuelle) > 800 && ( (puce_derniere_lue == puce_a_trouver - 1 && rampe > 0) || (puce_derniere_lue == puce_a_trouver + 1 && rampe < 0) )) {
            vitesse_actuelle = vitesse_actuelle - (sens * 100);
            if (abs(vitesse_actuelle) < 0) vitesse_actuelle = 0;
            analogWrite(enA, vitesse_actuelle);
            MonitMsg("aller rallenti" , puce_derniere_lue);
          }
          */
          if (commande == 4 || commande == 3) {
            //if ((( sens >= 0 && puce_derniere_lue >= puce_a_trouver ) || ( sens < 0 && puce_derniere_lue <= puce_a_trouver ) ) && tour <= 0) {
            if ( puce_derniere_lue == puce_a_trouver && tour <= 0) {
              //stopmoteur
              Vitesse_moteur(0, 0); //rampe a 0
              if (MONIT) Serial.println(" aller ou goto ok ");
              if (MONIT) Serial.print(puce_derniere_lue);
              if (MONIT) Serial.print(" ");
              if (MONIT) Serial.print(puce_a_trouver);
              if (MONIT) Serial.print(" ");
              if (MONIT) Serial.println(sens);
              MonitMsg("GOTO/OK" , puce_derniere_lue);
              delay(20);
              MonitMsg("EN", (int) ((uint32_t)millis() - temps_depart) );
              temps_tot_puce = 0;
              no_puce_actuelle = puce_a_trouver;
              tour = 0;
              commande = 0;
            }
          }
          // recalcule de la vitesse
          if (commande == 3) {
            if (vitesse_actuelle > 900) vitesse_temp = CalculVitesse(1000);
            else if (vitesse_actuelle < 601 ) vitesse_temp = CalculVitesse(500);
            else vitesse_temp = CalculVitesse(800);
            Vitesse_moteur(vitesse_temp, 0);
          }
          // DEBUT INIT
          if (commande >= 51 && commande <= (50 + NBR_TABLOTPS)) {
            if (TableauTemps[0][tablo_vitesse] >= 0) {   // AVANT
              //MonitMsg("INIT/AVANT/ATTENTEPUCE", puce_dinit);
              //MonitMsg("INIT/AVANT/PUCELUE", puce_derniere_lue);
              if ( puce_derniere_lue == 1  && puce_dinit > 2 ) { // tour complet , termine ?
                temps_boucle_total = (uint32_t)millis() - temps_boucle_total ; // gaff au temp de lecture
                TableauTemps[1][tablo_vitesse] = (uint32_t)millis() - temps_inter_init;
                TableauTemps[0][tablo_vitesse] = temps_boucle_total;
                commande = 0; // fin de init
                Vitesse_moteur(0, 0);
                delay(20);
                MonitMsg("INIT/TOURCOMPLET", tablo_vitesse);
                delay(20);
                MonitMsg("INIT/AVANT/TEMPS", TableauTemps[1][tablo_vitesse]);
                delay(20);
                MonitMsg("INIT/AVANT/TEMPSBOUCLETOTAL", temps_boucle_total );
                puce_dinit = 0;
                FlashTableauPuces(); // on a deja les puces ...
              }
              if (puce_derniere_lue == puce_dinit ) {
                TableauTemps[puce_derniere_lue][tablo_vitesse] = (uint32_t)millis() - temps_inter_init;
                delay(20);
                MonitMsg("INIT/AVANT/TEMPS", TableauTemps[puce_derniere_lue][tablo_vitesse]);
                temps_inter_init = (uint32_t)millis();
                puce_dinit += 1;
              }
              if (puce_derniere_lue > puce_dinit && puce_dinit > 0 ) { // on a sauté une puce
                MonitMsg("INIT/AVANT/ERR/PUCELUE", puce_derniere_lue);
                commande = 0; // fin de init
                Vitesse_moteur(0, 0);
                puce_dinit = 99;
              }
            } else {
              // sens <0 ARR
              MonitMsg("INIT/ARR/ATTENTEPUCE", puce_dinit);
              if ( puce_derniere_lue == 1 && puce_dinit < 2) { // tour complet ?
                temps_boucle_total = (uint32_t)millis() - temps_boucle_total ; // gaff au temp de lecture
                TableauTemps[0][tablo_vitesse] = temps_boucle_total;
                TableauTemps[1][tablo_vitesse] = (uint32_t)millis() - temps_inter_init;
                delay(20);
                MonitMsg("INIT/ARR/TOURCOMPLET", 1);
                delay(20);
                MonitMsg("INIT/ARR/TEMPS", TableauTemps[1][tablo_vitesse]);
                commande = 0; // fin de init
                Vitesse_moteur(0, 0);
                delay(20);
                MonitMsg("INIT/ARR/TEMPSBOUCLETOTAL", temps_boucle_total );
                FlashTableauPuces(); // on a deja les puces ...
                puce_dinit = 0;
              }

              if (puce_derniere_lue == puce_dinit ) {
                TableauTemps[puce_derniere_lue][tablo_vitesse] = (uint32_t)millis() - temps_inter_init;
                delay(20);
                MonitMsg("INIT/ARR/TEMPS", TableauTemps[puce_derniere_lue][tablo_vitesse]);
                temps_inter_init = (uint32_t)millis();
                puce_dinit -= 1;
              }
              if (puce_derniere_lue < puce_dinit && puce_derniere_lue > 1 ) { // on a sauté une puce
                MonitMsg("INIT/ARR/ERR/PUCELUE", puce_derniere_lue);
                commande = 0; // fin de init
                Vitesse_moteur(0, 0);
                puce_dinit = 99;
              }
            }
            delay(200);
          }
          // FIN INIT

          no_puce_actuelle = puce_derniere_lue;
          if (puce_derniere_lue == puce_a_trouver && tour > 0) {
            tour -= 1;
            if (MONIT) Serial.println("tour --");
            MonitMsg("TOURMOINS1" , tour);
          }
        }
      }
    }

  }
  delay(20);
}
